/*
 *	list.c
 *
 *	list management
 */

#include "mhpopd.h"
#include "kctype.h"


int list_count(list)
char **list;
{
	int i;

	if (!list) return(0);
	for (i = 0; list[i]; i++);

	return(i);
}

char **list_init(VOID_A)
{
	char **new;

	if (!(new = (char **)Xmalloc(sizeof(char *)))) return(NULL);
	new[0] = NULL;

	return(new);
}

char **list_add(list, n, s, len)
char **list;
int n;
char *s;
ALLOC_T len;
{
	char **new;

	if (n < 0) n = list_count(list);
	if (len == (ALLOC_T)-1) len = strlen(s);

	if (!(new = (char **)Xrealloc(list, (n + 1 + 1) * sizeof(char *)))
	|| !(s = Xstrndup(s, len))) {
		while (n-- > 0) Xfree(list[n]);
		Xfree(list);
		return(NULL);
	}
	new[n] = s;
	new[++n] = NULL;

	return(new);
}

char **list_tryadd(list, s)
char **list, *s;
{
	char **new;
	int n;

	n = list_count(list);
	if (!(new = (char **)Xrealloc(list, (n + 1 + 1) * sizeof(char *)))) {
		Xfree(s);
		return(NULL);
	}
	new[n] = s;
	new[++n] = NULL;

	return(new);
}

VOID list_free(list)
char **list;
{
	int i;

	if (!list) return;

	for (i = 0; list[i]; i++) Xfree(list[i]);
	Xfree(list);
}
