/*
 *	args.c
 *
 *	to Get Argument List
 */

#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "lipsf.h"
#include "var.h"

#define MAXARGS	256

u_char *styletitle;

extern char *optarg;
extern int optind;
extern int kanjicode;

extern VOID_P malloc();
extern VOID free();
extern int atoi();

#if	MSDOS
#define	strcasecmp2	stricmp
#define	strncasecmp2	strnicmp
#else
static int strcasecmp2();
static int strncasecmp2();
#endif
VOID varinit();
VOID chgmaxlinecol();
VOID chgwidhight();
static int gettwoarg();
static int trunclimit();
static int arrangeheadfoot();
VOID argfile();
int getarg();

extern VOID error();
extern VOID usage();
extern char *strdup2();
#if	MSDOS
extern int getopt(int, char **, char *);
#endif


#if	!MSDOS
static int strcasecmp2(s1, s2)
char *s1, *s2;
{
	int c1, c2;

	for (;;) {
		c1 = *(s1++);
		if (c1 >= 'a' && c1 <= 'z') c1 += 'A' - 'a';
		c2 = *(s2++);
		if (c2 >= 'a' && c2 <= 'z') c2 += 'A' - 'a';
		if (!c1 || c1 != c2) return(c1 - c2);
	}
}

static int strncasecmp2(s1, s2, n)
char *s1, *s2;
int n;
{
	int c1, c2;

	while (--n >= 0) {
		c1 = *(s1++);
		if (c1 >= 'a' && c1 <= 'z') c1 += 'A' - 'a';
		c2 = *(s2++);
		if (c2 >= 'a' && c2 <= 'z') c2 += 'A' - 'a';
		if (!c1 || c1 != c2) return(c1 - c2);
	}
	return(0);
}
#endif

VOID varinit()
{
	lipsmode	= LIPSMODE;
	cassette	= CASSETTE;
	islandscape	= ISLANDSCAPE;
	isvirtical	= ISVIRTICAL;
	fontpattern	= FONTPATTERN;
	papersize	= PAPERSIZE;
	lettersize	= LETTERSIZE;
	linehight	= LINEHIGHT;
	columnwidth	= COLUMNWIDTH;
	printnum	= PRINTNUM;
	topmargin	= TOPMARGIN;
	bottommargin	= -1;
	leftmargin	= LEFTMARGIN;
	rightmargin	= -1;
	headerstr	= NULL;
	footerstr	= NULL;
	headermargin	= -1;
	footermargin	= -1;
	usrmaxcolumns	= -1;
	usrmaxlines	= -1;
	tabposition	= TABPOSITION;
	isconcat	= ISCONCAT;
	overlay		= OVERLAY;
	controlchar	= CONTROLCHAR;
	controlmode	= 0;
	iszerosup	= ISZEROSUP;
	iskanjinum	= ISKANJINUM;
	istoupper	= ISTOUPPER;
	istolower	= ISTOLOWER;
	paperwidth	= A4WIDTH;
	paperhight	= A4HIGHT;
	maxsteps	= MAXSTEPS;
	stepcolumns	= -1;
	firstpage	= FIRSTPAGE;
	startpage	= -1;
	endpage		= -1;

	widesize	= longsize	= broadsize	= topscript	=
	subscript	= underline	= doubleunder	= forcedchar	=
	amikake		= exclusive	= outline	= patternfill	=
	shadow		= kumimoji	= returnhight	= parentheses	=
	centering	= flushright	= leftindent	= rightindent	=
	iskinsoku	= iswordwrap	= isjustify	= isinfo	= 0;
}

VOID stackvar(push)
int push;
{
	static int d_isvirtical;
	static int d_fontpattern;
	static int d_lettersize;
	static int d_linehight;
	static int d_columnwidth;
	static int d_tabposition;
	static int d_isconcat;
	static int d_controlmode;
	
	static int d_iskinsoku;
	static int d_iswordwrap;
	static int d_isjustify;

	if (push) {
		d_isvirtical	= isvirtical;
		d_fontpattern	= fontpattern;
		d_lettersize	= lettersize;
		d_linehight	= linehight;
		d_columnwidth	= columnwidth;
		d_tabposition	= tabposition;
		d_isconcat	= isconcat;
		d_controlmode	= controlmode;

		d_iskinsoku	= iskinsoku;
		d_iswordwrap	= iswordwrap;
		d_isjustify	= isjustify;
	}
	else {
		isvirtical	= d_isvirtical;
		fontpattern	= d_fontpattern;
		lettersize	= d_lettersize;
		linehight	= d_linehight;
		columnwidth	= d_columnwidth;
		tabposition	= d_tabposition;
		isconcat	= d_isconcat;
		controlmode	= d_controlmode;

		widesize	= longsize	= broadsize	=
		topscript	= subscript	= underline	=
		doubleunder	= forcedchar	= amikake	=
		exclusive	= outline	= patternfill	=
		shadow		= kumimoji	= returnhight	=
		parentheses	= centering	= flushright	=
		leftindent	= rightindent	= 0;

		iskinsoku	= d_iskinsoku;
		iswordwrap	= d_iswordwrap;
		isjustify	= d_isjustify;

		chgmaxlinecol();
	}
}

VOID chgmaxlinecol()
{
	long max, width, hight;
	int right, bottom;

	right = (rightmargin < 0) ? MINRIGHTMARGIN : rightmargin;
	bottom = (bottommargin < 0) ? MINBOTTOMMARGIN : bottommargin;

	if (islandscape) {
		width = paperhight;
		hight = paperwidth;
	}
	else {
		width = paperwidth;
		hight = paperhight;
	}

	max = width - leftmargin - right;
	max *= 100;
	max *= (lipsmode == 3) ? 300 : 240;
	max /= 2540;
	max -= 4;
	dotprintwidth = max;

	max += columnwidth;
	max /= columnwidth + lettersize / 2;
	automaxcolumns = (int)max;

	if (usrmaxcolumns < 0 || usrmaxcolumns > max)
		realmaxcolumns = automaxcolumns;
	else realmaxcolumns = usrmaxcolumns;

	if (maxsteps <= 1) maxcolumns = realmaxcolumns;
	else {
		max /= maxsteps;
		if (usrmaxcolumns < 0) autostepcolumns = (int)max;
		else autostepcolumns = usrmaxcolumns / maxsteps;
		if (stepcolumns < 0) maxcolumns = autostepcolumns;
		else if (stepcolumns > max) maxcolumns = (int)max;
		else maxcolumns = stepcolumns;
	}

	max = hight - topmargin - bottom;
	max *= 100;
	if (headerstr) max -= (long)headermargin * 100;
	if (footerstr) max -= (long)footermargin * 100;
	max *= (lipsmode == 3) ? 300 : 240;
	max /= 2540;
	if (headerstr) max -= lettersize;
	if (footerstr) max -= lettersize;
	max += linehight;
	max /= linehight + lettersize;
	automaxlines = (int)max;
	if (usrmaxlines < 0 || usrmaxlines > max) maxlines = automaxlines;
	else maxlines = usrmaxlines;
}

VOID chgwidhight()
{
	switch (papersize) {
		case 12:
			paperwidth = A3WIDTH;
			paperhight = A3HIGHT;
			break;
		case 14:
			paperwidth = A4WIDTH;
			paperhight = A4HIGHT;
			break;
		case 16:
			paperwidth = A5WIDTH;
			paperhight = A5HIGHT;
			break;
		case 18:
			paperwidth = HAGAKIWIDTH;
			paperhight = HAGAKIHIGHT;
			break;
		case 24:
			paperwidth = B4WIDTH;
			paperhight = B4HIGHT;
			break;
		case 26:
			paperwidth = B5WIDTH;
			paperhight = B5HIGHT;
			break;
		default:
			break;
	}
}

static int gettwoarg(str, ch, x, y)
char *str;
int ch;
int *x, *y;
{
	char *cp = str;
	int tmp = 2;

	while (isdigit(*cp)) cp++;
	if (cp != str) *x = atoi(str);
	else tmp = 0;
	if (*cp == '\0') return(1);
	else if (*cp != ch) return(-1);
	str = ++cp;
	while (isdigit(*cp)) cp++;
	if (cp != str) *y = atoi(str);
	else tmp = 0;
	if (*cp != '\0') return(-1);
	return(tmp);
}

static int trunclimit(arg, min, max)
char *arg;
int min, max;
{
	int tmp;

	tmp = atoi(arg);
	if (tmp < min) tmp = min;
	else if (tmp > max) tmp = max;
	return(tmp);
}

static int arrangeheadfoot(arg)
char *arg;
{
	switch (*arg) {
		case 'H':
			headermargin = trunclimit(arg + 1,
				MINHEADERMARGIN, MAXHEADERMARGIN);
			break;
		case 'F':
			footermargin = trunclimit(arg + 1,
				MINFOOTERMARGIN, MAXFOOTERMARGIN);
			break;
		case 'z':
			iszerosup = 1;
			break;
		case 'k':
			iskanjinum = 1;
			break;
		case 'U':
			istoupper = 1;
			break;
		case 'L':
			istolower = 1;
			break;
		default:
			error(EINVAL);
			return(0);
			break;
	}

	return(1);
}

VOID argfile(filename)
char *filename;
{
	FILE *fp;
	int argc = 1;
	char *argv[MAXARGS];
	char *argbuf, *argbuf2;
	struct stat buf;
	int i, j, inarg, quote, bslash;
	int c;

	if (!(fp = fopen(filename, "r"))) error(-1);
	if (fstat(fileno(fp), &buf)) error(-1);
	if (!buf.st_size) {
		fclose(fp);
		return;
	}

	if (!(argbuf = (char *)malloc(buf.st_size + 1))) error(-1);
	if (!(argbuf2 = (char *)malloc(buf.st_size + 1))) error(-1);
	if (!(i = fread(argbuf, sizeof(char), buf.st_size, fp))) {
		error(errno);
		return;
	}
	fclose(fp);

	argbuf[i] = '\0';
	inarg = quote = bslash = 0;
	styletitle = NULL;
	i = 0;

	if (*argbuf == ';') {
		do i++;
		while (argbuf[i] && argbuf[i] != '\n');
		if (i > 1) {
			if (!(styletitle = (u_char *)malloc(i))) error(-1);
			strncpy(styletitle, argbuf + 1, i - 1);
			styletitle[i - 1] = '\0';
		}
		if (argbuf[i]) i++;
	}
	for (j = 0; c = argbuf[i]; i++) {
		if (bslash) {
			bslash = 0;
			if (!inarg) argv[argc++] = &argbuf2[j];
			argbuf2[j++] = c;
			inarg = 1;
		}
		else switch(c) {
			case '\n':
				if (quote) {
					if (!inarg) argv[argc++] = &argbuf2[j];
					argbuf2[j++] = '\0';
				}
				else if (inarg) argbuf2[j++] = '\0';
				inarg = quote = 0;

				if (argbuf[i + 1] == ';') {
					i++;
					do i++;
					while (argbuf[i] && argbuf[i] != '\n');
					if (!argbuf[i]) i--;
				}
				break;
			case '\t':
			case ' ':
				if (quote) {
					if (!inarg) argv[argc++] = &argbuf2[j];
					argbuf2[j++] = c;
					inarg = 1;
				}
				else {
					if (inarg) argbuf2[j++] = '\0';
					inarg = quote = 0;
				}
				break;
			case '\\':
				bslash = 1;
				break;
			case '\"':
				if (!quote) quote = 1;
				else {
					if (!inarg) argv[argc++] = &argbuf2[j];
					inarg = 1;
					quote = 0;
				}
				break;
			default:
				if (!inarg) argv[argc++] = &argbuf2[j];
				argbuf2[j++] = c;
				inarg = 1;
				break;
		}
	}
	argbuf2[j] = '\0';
	argv[0] = filename;
#ifdef	DEBUG
	for (i = 0; i < argc; i++) {
	fprintf(stderr, "[");
	for (j = 0; j < strlen(argv[i]); j++)
		if (isprint(argv[i][j])) fputc(argv[i][j], stderr);
	fprintf(stderr, "]\n");
	}
#endif
	getarg(argc, argv, 1);
	free(argbuf);
}

int getarg(argc, argv, recurse)
int argc;
char *argv[];
int recurse;
{
	int c, i;

	optarg = NULL;
	optind = 1;
	if (!recurse) varinit();

	while ((c = getopt(argc, argv,
	"p:m:d:f:J:s:h:w:C:A:#:t:c:l:T:B:L:R:H:F:O:S:r:P:vkKi23@:?")) != EOF)
	switch (c) {
		case 'p':
			if (!strcasecmp2(optarg, "a3")) papersize = 12;
			else if (!strcasecmp2(optarg, "a4")) papersize = 14;
			else if (!strcasecmp2(optarg, "a5")) papersize = 16;
			else if (!strcasecmp2(optarg, "hagaki")) papersize = 18;
			else if (!strcasecmp2(optarg, "b4")) papersize = 24;
			else if (!strcasecmp2(optarg, "b5")) papersize = 26;
			else if (gettwoarg(optarg, 'x',
				&paperwidth, &paperhight) == 2) {
				papersize = 80;
				if (paperwidth < MINPAPERWIDTH)
					paperwidth = MINPAPERWIDTH;
				else if (paperwidth > MAXPAPERWIDTH)
					paperwidth = MAXPAPERWIDTH;
				if (paperhight < MINPAPERHIGHT)
					paperhight = MINPAPERHIGHT;
				else if (paperhight > MAXPAPERHIGHT)
					paperhight = MAXPAPERHIGHT;
			}
			else {
				error(EINVAL);
				return(0);
			}
			chgwidhight();
			break;
		case 'm':
			if (!strncasecmp2(optarg, "a", 1))
				cassette = 0;
			else if (!strncasecmp2(optarg, "m", 1))
				cassette = 1;
			else if (!strncasecmp2(optarg, "l", 1))
				cassette = 2;
			else if (!strncasecmp2(optarg, "u", 1))
				cassette = 3;
			else {
				error(EINVAL);
				return(0);
			}
			break;
		case 'd':
			if (!strncasecmp2(optarg, "p", 1))
				islandscape = 0;
			else if (!strncasecmp2(optarg, "l", 1))
				islandscape = 1;
			else {
				error(EINVAL);
				return(0);
			}
			break;
		case 'f':
			if (!strncasecmp2(optarg, "m", 1))
				fontpattern = 80;
			else if (!strncasecmp2(optarg, "g", 1))
				fontpattern = 81;
			else if (!strncasecmp2(optarg, "r", 1))
				fontpattern = 82;
			else {
				error(EINVAL);
				return(0);
			}
			break;
		case 's':
			lettersize = trunclimit(optarg,
				MINLETTERSIZE, MAXLETTERSIZE);
			break;
		case 'h':
			linehight = trunclimit(optarg,
				MINLINEHIGHT, MAXLINEHIGHT);
			break;
		case 'w':
			columnwidth = trunclimit(optarg,
				MINCOLUMNWIDTH, MAXCOLUMNWIDTH);
			break;
		case 'C':
			controlmode = 1;
#if	MSDOS
			if (*optarg == '\\' && strlen(optarg) == 2) {
				controlchar = *(optarg + 1);
				break;
			}
#endif
			if (strlen(optarg) > 1) {
				error(EINVAL);
				return(0);
			}
			controlchar = *optarg;
			break;
		case 'A':
			if (!arrangeheadfoot(optarg)) return(0);
			break;
		case 'J':
			if (!strncasecmp2(optarg, "s", 1))
				kanjicode = SJIS;
			else if (!strncasecmp2(optarg, "e", 1)
			|| !strncasecmp2(optarg, "u", 1))
				kanjicode = EUC;
			else if (!strncasecmp2(optarg, "j", 1))
				kanjicode = JIS;
			break;
		case '#':
			printnum = trunclimit(optarg,
				MINPRINTNUM, MAXPRINTNUM);
			break;
		case 't':
			tabposition = trunclimit(optarg,
				MINTABPOSITION, MAXTABPOSITION);
			break;
		case 'c':
			usrmaxcolumns = trunclimit(optarg,
				MINMAXCOLUMNS, MAXMAXCOLUMNS);
			break;
		case 'l':
			usrmaxlines = trunclimit(optarg,
				MINMAXLINES, MAXMAXLINES);
			break;
		case 'T':
			topmargin = trunclimit(optarg,
				MINTOPMARGIN, MAXTOPMARGIN);
			break;
		case 'B':
			bottommargin = trunclimit(optarg,
				MINBOTTOMMARGIN, MAXBOTTOMMARGIN);
			break;
		case 'L':
			leftmargin = trunclimit(optarg,
				MINLEFTMARGIN, MAXLEFTMARGIN);
			break;
		case 'R':
			rightmargin = trunclimit(optarg,
				MINRIGHTMARGIN, MAXRIGHTMARGIN);
			break;
		case 'H':
			if (!(headerstr = (u_char *)strdup2(optarg))) error(-1);
			if (headermargin < 0) headermargin = HEADERMARGIN;
			break;
		case 'F':
			if (!(footerstr = (u_char *)strdup2(optarg))) error(-1);
			if (footermargin < 0) footermargin = FOOTERMARGIN;
			break;
		case 'O':
			overlay = atoi(optarg);
			if (overlay < 0 || overlay > 5) overlay = 0;
			break;
		case 'S':
			if (gettwoarg(optarg, ',', &maxsteps, &i) == 2) {
				stepcolumns = i;
				if (stepcolumns < MINSTEPCOLUMNS)
					stepcolumns = MINSTEPCOLUMNS;
				else if (stepcolumns > MAXSTEPCOLUMNS)
					stepcolumns = MAXSTEPCOLUMNS;
			}
			if (maxsteps < MINMAXSTEPS)
				maxsteps = MINMAXSTEPS;
			else if (maxsteps > MAXMAXSTEPS)
				maxsteps = MAXMAXSTEPS;
			break;
		case 'r':
			if (gettwoarg(optarg, '-', &startpage, &endpage) == 1)
				endpage = startpage;
			if (startpage < MINSTARTPAGE)
				startpage = -1;
			else if (startpage > MAXSTARTPAGE)
				startpage = MAXSTARTPAGE;
			else startpage--;
			if (endpage < MINENDPAGE)
				endpage = -1;
			else if (endpage > MAXENDPAGE)
				endpage = MAXENDPAGE;
			else endpage--;
			break;
		case 'P':
			firstpage = trunclimit(optarg,
				MINFIRSTPAGE, MAXFIRSTPAGE);
			break;
		default:
			switch (c) {
				case 'v':
				isvirtical = 4;
					break;
				case 'k':
					isconcat = 1;
					break;
				case 'K':
					iskinsoku = 1;
					break;
				case 'i':
					isinfo = 1;
					break;
				case '2':
				case '3':
					lipsmode = c - '0';
					break;
				case '@':
					if (recurse) {
						error(EMFILE);
						return(0);
					}
					c = optind;
					optind = 1;
					argfile(optarg);
					optind = c;
					break;
				case '?':
					usage(0);
					break;
				default :
					error(EINVAL);
					return(0);
					break;
			}
			break;
	}

	if (!recurse) chgmaxlinecol();
	else if (optind != argc) error(EINVAL);
	return(optind);
}
