/*
 *	dosprn.c
 *
 *	MS-DOS Printer Driver
 */

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <stdarg.h>
#include "lipsf.h"

#define MAXCOLS 512

#define	PRN98	0x1a
#define	PRNJ31	0x17
#define	PRNDOSV	0x17

extern FILE *null;

#ifdef	PC98
int nohighreso;
#endif


int lopen()
{
#ifdef	PC98
	union REGS in, out;

	nohighreso = ((*(char far *)0x00000501) & 0x08) ? 0x00 : 0x01;
	in.h.ah = 0x10;
	int86(PRN98, &in, &out);
	return(out.h.al);
#else
	return(0);
#endif
} 

int lputc(c, stream)
int c;
FILE *stream;
{
	union REGS in, out;

	if (stream) {
		if (stream == null) return(c);
		return(fputc(c, stream));
	}
	else {
		do {
			in.h.al = (u_char) c;
#ifdef	PC98
			in.h.ah = 0x11;
			int86(PRN98, &in, &out);
		} while(out.h.ah != nohighreso);
#endif
#ifdef	J3100
			in.h.ah = 0x84;
			in.x.dx = 0;
			int86(PRNJ31, &in, &out);
		} while(out.h.ah & 0x29);
#endif
#ifdef	DOSV
			in.h.ah = 0x00;
			int86(PRNDOSV, &in, &out);
		} while(out.h.ah != 0x90);
#endif
	return(c);
	}
}

int lprintf(FILE *stream, u_char *fmt, ...)
{
	va_list args;
	int i, len;
	u_char buf[MAXCOLS];

	va_start(args, fmt);

	if (stream) {
		if (stream != null) len = vfprintf(stream, fmt, args);
		else {
			vsprintf(buf, fmt, args);
			len = strlen(buf);
		}
	}
	else {
		vsprintf(buf, fmt, args);
		for (i = 0; buf[i]; i++) lputc(buf[i], NULL);
		len = i;
	}
	va_end(args);
	return(len);
}
